#include "mbed.h"

#include "FastIO.h"

DigitalOut myled(LED1);
 int pixel =0;
 int validRegion = 0;
// int DE =0;
// DigitalOut red(p15);  P0.23
// DigitalOut green(p16); P0.24
// DigitalOut blue(p17); P0.25
// DigitalOut clk(p11); P0.18
// DigitalOut de(p13); P0.15
// DigitalOut hsync(p20);  p5 P0.9  (these need to be changed to be port 0) 
// DigitalOut vsync(p19);  p6 P0.8
 
 Ticker clockCall;
 
 int hCount = 0;
 int vCount = 0;
 // ints for different pin states.
 uint32_t i_clockPin =0;
 uint32_t i_red = 0;
 uint32_t i_blue = 0;
 uint32_t i_green = 0;
 uint32_t i_de = 0;
 uint32_t i_hsync =0;
 uint32_t i_vsync = 0;
// need to work out what the mask for a single write is. :/
#define PIN_MASK 0xFFFFFFFF

//uint32_t bitMask = 0;
 


FastPortOut<Port0, PIN_MASK> DataOutPort;
uint32_t pinSet =0;

void writePort(){
// this function takes all the flags and munges them into a single port write.
    pinSet = 0;
    pinSet = i_clockPin << 18;
    pinSet = pinSet || i_red <<23;
    pinSet = pinSet || i_blue <<25;
    pinSet = pinSet || i_green <<24;
    pinSet = pinSet || i_hsync << 9;
    pinSet = pinSet || i_vsync << 8;
    pinSet = pinSet || i_de << 15;

    DataOutPort.write(pinSet);
} 

void scanFrame(){
//get called by scanline at the end of each line.

    if(vCount>526  ){
        vCount=0;
    }
    if (vCount < 2 ){
       i_vsync=0;
    }else{
        i_vsync=1;
    }   
    if(vCount > 33 && vCount < 514){
        validRegion =1;
    }   
    vCount++;
}


void writePixel(){
    //alternate colours
    i_red=pixel;
    pixel = !pixel;
}

void scanLine(){ // horizontal scans.  this is the most frequent and the inner loop.  call this from the clock.
    if(hCount> 800){
        scanFrame();
        hCount =0;
    }   
    if(hCount < 97){
        i_hsync=0;
    }else{
        i_hsync=1;
    }
    if(hCount > 144 && hCount <785 && validRegion ){
        //output data here
        i_de=1;
        writePixel();
    }
    else
    {
        i_de=0;
    }
    hCount++;   
}



void clkPin(){
    i_clockPin = !i_clockPin;
    if(i_clockPin){// when clock pin is high, calculate all the values
        scanLine();
    }
    writePort();// update the pin status
    
}

int main() {
   
   //initialisation
   //setup timers
   //setup pins
   //start loop   
   // setup timer for 500kHz Call.
   clockCall.attach_us(&clkPin, 1);
   myled =1;
   while(1){
    //do SFA.
    myled = !myled;
    wait(0.2); // does this block everything? should probably check this
   }
      
}
